#ifndef WESTON_SCREENSHOOTER_SERVER_PROTOCOL_H
#define WESTON_SCREENSHOOTER_SERVER_PROTOCOL_H

#ifdef  __cplusplus
extern "C" {
#endif

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

struct wl_client;
struct wl_resource;

struct weston_screenshooter;
struct wl_buffer;
struct wl_output;

extern const struct wl_interface weston_screenshooter_interface;

struct weston_screenshooter_interface {
	/**
	 * shoot - (none)
	 * @output: (none)
	 * @buffer: (none)
	 */
	void (*shoot)(struct wl_client *client,
		      struct wl_resource *resource,
		      struct wl_resource *output,
		      struct wl_resource *buffer);
};

#define WESTON_SCREENSHOOTER_DONE	0

#define WESTON_SCREENSHOOTER_DONE_SINCE_VERSION	1

static inline void
weston_screenshooter_send_done(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, WESTON_SCREENSHOOTER_DONE);
}

#ifdef  __cplusplus
}
#endif

#endif
